searchData={"items":[{"type":"module","title":"GenRouter","doc":"Router to parse messages,\nmodeled by the idea of simplified Plug.Conn router.","ref":"GenRouter.html"},{"type":"macro","title":"GenRouter.__using__/1","doc":"Custom router factory","ref":"GenRouter.html#__using__/1"},{"type":"macro","title":"GenRouter.match/3","doc":"Defines default route or a route inside a pipeline.\n\nSee `pipeline/2` for more information.","ref":"GenRouter.html#match/3"},{"type":"function","title":"GenRouter.match_in_scope/7","doc":"Match specific route in scope of routes.\n\nWe ensure that all paths and suffixs are matched with slash for consistency.","ref":"GenRouter.html#match_in_scope/7"},{"type":"macro","title":"GenRouter.pipe_through/1","doc":"Defines a pipeline to send the connection through.\n\nSee `pipeline/2` for more information.","ref":"GenRouter.html#pipe_through/1"},{"type":"macro","title":"GenRouter.pipeline/2","doc":"Defines a plug pipeline.\n\nPipelines are defined at the router root and can be used\nfrom any scope.","ref":"GenRouter.html#pipeline/2"},{"type":"macro","title":"GenRouter.plug/2","doc":"Defines a plug inside a pipeline.\n\nSee `pipeline/2` for more information.","ref":"GenRouter.html#plug/2"},{"type":"type","title":"GenRouter.route/0","doc":"","ref":"GenRouter.html#t:route/0"},{"type":"macro","title":"GenRouter.scope/3","doc":"Defines scope of routers with pipelines.","ref":"GenRouter.html#scope/3"},{"type":"behaviour","title":"GenRouter.Behaviour","doc":"Callbacks for custom implementation for the Router.","ref":"GenRouter.Behaviour.html"},{"type":"type","title":"GenRouter.Behaviour.assigns/0","doc":"","ref":"GenRouter.Behaviour.html#t:assigns/0"},{"type":"callback","title":"GenRouter.Behaviour.deliver/5","doc":"Renders the view and deliver response to the end client.","ref":"GenRouter.Behaviour.html#c:deliver/5"},{"type":"callback","title":"GenRouter.Behaviour.match_message/6","doc":"Function which converts generic message into GenRouter.Conn structure\nthen match it according to the router specification.","ref":"GenRouter.Behaviour.html#c:match_message/6"},{"type":"type","title":"GenRouter.Behaviour.message/0","doc":"","ref":"GenRouter.Behaviour.html#t:message/0"},{"type":"type","title":"GenRouter.Behaviour.opts/0","doc":"","ref":"GenRouter.Behaviour.html#t:opts/0"},{"type":"type","title":"GenRouter.Behaviour.params/0","doc":"","ref":"GenRouter.Behaviour.html#t:params/0"},{"type":"type","title":"GenRouter.Behaviour.path/0","doc":"","ref":"GenRouter.Behaviour.html#t:path/0"},{"type":"type","title":"GenRouter.Behaviour.router/0","doc":"","ref":"GenRouter.Behaviour.html#t:router/0"},{"type":"type","title":"GenRouter.Behaviour.scope/0","doc":"","ref":"GenRouter.Behaviour.html#t:scope/0"},{"type":"type","title":"GenRouter.Behaviour.template/0","doc":"","ref":"GenRouter.Behaviour.html#t:template/0"},{"type":"type","title":"GenRouter.Behaviour.view/0","doc":"","ref":"GenRouter.Behaviour.html#t:view/0"},{"type":"module","title":"GenRouter.Conn","doc":"Structure which represents connection with Telegram bot.\nInspired by %Plug.Conn{}, adapted for bots.\n\nAttributes:\n\n  * __skip__: system buffer to keep track of skipped scopes;\n  * path: route to controller which should handle this object;\n  * params: payload which will be passed to controller;\n  * assigns: non-parsed data assigned by a system (auth, etc);\n  * scope: local scope of current request, clears for each new route;\n  * code: response code, we use common HTTP codes, currently only 200 is supported;\n  * response: response payload, usually JSON;\n  * halted: stop the pipeline execution if conn was settled.","ref":"GenRouter.Conn.html"},{"type":"function","title":"GenRouter.Conn.assign/3","doc":"Assign variable to current request.","ref":"GenRouter.Conn.html#assign/3"},{"type":"function","title":"GenRouter.Conn.build/2","doc":"Build Conn object with system fields","ref":"GenRouter.Conn.html#build/2"},{"type":"function","title":"GenRouter.Conn.complete/4","doc":"Update state and complete the current request.","ref":"GenRouter.Conn.html#complete/4"},{"type":"function","title":"GenRouter.Conn.forward/4","doc":"Put the next path after the current request.\n\nIt unhalts settled conn, so all the pipelines will be executed again.","ref":"GenRouter.Conn.html#forward/4"},{"type":"function","title":"GenRouter.Conn.halt/1","doc":"Halt execution pipeline, Conn is settled.","ref":"GenRouter.Conn.html#halt/1"},{"type":"function","title":"GenRouter.Conn.reset_router_matches/2","doc":"Reset router matching pipeline","ref":"GenRouter.Conn.html#reset_router_matches/2"},{"type":"type","title":"GenRouter.Conn.t/0","doc":"","ref":"GenRouter.Conn.html#t:t/0"},{"type":"module","title":"GenRouter.Controller","doc":"Boilerplate to define controller in scope of GenRouter.","ref":"GenRouter.Controller.html"},{"type":"macro","title":"GenRouter.Controller.__using__/1","doc":"Custom controller factory.","ref":"GenRouter.Controller.html#__using__/1"},{"type":"macro","title":"GenRouter.Controller.plug/2","doc":"Callable plugs in controllers.","ref":"GenRouter.Controller.html#plug/2"},{"type":"extras","title":"GenRouter","doc":"# GenRouter\n\nSometimes you need a routing capabilities which can work with a generic connection object\nand you can't use existing routing modules included in `Phoenix` and `Plug.Router` packages.\n\nOne of the use cases is the routing of messages for chatbots.","ref":"readme.html"},{"type":"extras","title":"Installation - GenRouter","doc":"Update your list of dependencies in `mix.exs`:\n\n```elixir \ndef deps do\n  [\n    {:gen_router, \"~> 0.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - GenRouter","doc":"[Hex docs](https://hexdocs.pm/gen_router)\n\nRouter configuration is similar to Phoenix routing system, but we don't support HTTP methods and define only `match` rules.\n\nAs with Phoenix, you can capture variables in `conn.params` with colon notations.\nRoute `/book/:name/p/:page` will match url like `/book/sweet_home/p/3` and will populate\nparams of your `conn` object with `%{\"name\" => \"sweet_home\", \"page\" => \"3\"}`. \nAll the parsed values will be strings.\n\nYou need to define `match_message` and `deliver` callbacks according to `GenRouter.Behaviour` behviour.","ref":"readme.html#usage"},{"type":"extras","title":"match_message - GenRouter","doc":"Transforms generic input into %GenRouter.Conn{} object and execute the routing process.\n\nArguments:\n\n* `router_module` - router module which implements GenRouter\n* `message` - client request payload, %{} by default\n* `path` - client request path\n* `scope` - client request scope, %{} by default\n* `assigns` - data assigned by the system (authorization, locale etc)\n* `opts` - request options","ref":"readme.html#match_message"},{"type":"extras","title":"deliver - GenRouter","doc":"Replacement of `render` function in Phoenix routing and responsible for delivering routing results to your clients.\n\nArguments:\n\n* `conn` - connection object\n* `view` - view module which will be used for rendering\n* `template` - name of template to render\n* `params` - rendering params\n* `opts` - delivery options","ref":"readme.html#deliver"},{"type":"extras","title":"Sample router - GenRouter","doc":"```\ndefmodule App.Router do\n  use GenRouter\n  alias App.Controller.FirstController\n  alias App.Controller.Model4Controller\n  alias App.Controller.ErrorController\n\n  pipeline :authed do\n    plug App.Plug.Authorize\n  end\n\n  scope :default, \"/\" do\n    pipe_through [:authed]\n\n    match \"/\", FirstController, :index\n    match \"/action2\", FirstController, :index\n    match \"/model3/:id\", FirstController, :protected_action\n  end\n\n  scope :model4_scope, \"/model4\" do\n    pipe_through [:authed]\n\n    match \"/\", FirstController, :index\n  end\n\n  match \"*\", ErrorController, :not_found\n\n  @impl true\n  def match_message(router_module, message, path, scope, assigns, opts) do\n    conn =\n      GenRouter.Conn.build(router_module, %{\n        path: path,\n        params: %{message: message},\n        assigns: assigns,\n        scope: scope\n      })\n    router_module.do_match(conn, opts)\n  end\n\n  @impl true\n  def deliver(conn, _view, _template, _params, _opts) do\n    conn\n  end\nend\n```","ref":"readme.html#sample-router"},{"type":"extras","title":"Sample controller - GenRouter","doc":"```\ndefmodule GenRouter.Controller.FirstController do\n  use GenRouter.Controller\n\n  plug GenRouter.Plug.FetchCommonResource\n  plug GenRouter.Plug.FetchResource when action in [:protected_action]\n\n  @spec index(Conn.t(), any()) :: Conn.t()\n  def index(conn, _opts) do\n    complete(conn, \"index\")\n  end\n\n  @spec protected_action(Conn.t(), any()) :: Conn.t()\n  def protected_action(conn, _opts) do\n    complete(conn, \"protected_action\")\n  end\n\n  @spec not_found(GenRouter.Conn.t(), any()) :: GenRouter.Conn.t()\n  def not_found(conn, _opts) do\n    complete(conn, nil, %{}, 404)\n  end\nend\n```","ref":"readme.html#sample-controller"},{"type":"extras","title":"Sample plug - GenRouter","doc":"```\ndefmodule GenRouter.Plug.Authorize do\n  @doc false\n  def call(%{assigns: %{authorized: true}} = conn, _opts), do: conn\n  def call(conn, _opts), do: GenRouter.Conn.complete(conn, \"forbidden\", %{}, 403)\nend\n```","ref":"readme.html#sample-plug"},{"type":"extras","title":"Other - GenRouter","doc":"__This library is in it's early beta, use on your own risk. Pull requests / reports / feedback are welcome.__","ref":"readme.html#other"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}